; inc_DirTreeView.ahk
; Contains subroutines, etc. related to the direcory TreeView and its associated events

;----- Directory tree -----
BuildDirTree:
; configure directory browser tree based on current root directory 
; does not rebuild file lists!
	TreeRoot = %gRootDir%
	; Add folders and their subfolders to the tree.
	; Display the status in case loading takes a long time:
	SplashImage, , t m1 fm8 fs8, This may take a long time for big folders., Loading folder structure for`n%TreeRoot%`n, jIDEE initializing..., FontName
	TV_Delete()									; delete old items
	tvTopItem := TV_Add(TreeRoot, 0, "Icon4 Expand")	; add top item, Icon4 is defined during program launch (ImageListID)
	AddSubFoldersToTree(TreeRoot, tvTopItem)	; add remaining items
	TV_Modify(tvTopItem, "Select")				; select top item
	SplashImage,Off
	return

AddSubFoldersToTree(Folder, ParentItemID = 0)
; from TreeView example in AHK help hile 
; TODO: replace "Icon4" with an icon from Silk or similar CC source?
{
    ; This function adds to the TreeView all subfolders in the specified folder.
    ; It also calls itself recursively to gather nested folders to any depth.
	Loop %Folder%\*.*, 2  ; Retrieve all of Folder's sub-folders.
        AddSubFoldersToTree(A_LoopFileFullPath, TV_Add(A_LoopFileName, ParentItemID, "Icon4 Expand"))
}

DirTree_event:
; Adapted from TreeView example in AHK help hile
; This subroutine handles user actions (such as clicking).
; TODO: right-click option to create new folder, delete folder
	;if A_GuiEvent 
	;	msgbox right click
	
	TV_GetText(SelectedItemText, A_EventInfo)
	ParentID := A_EventInfo
	Loop  ; Build the full path to the selected folder.
	{
		ParentID := TV_GetParent(ParentID)
		if not ParentID  ; No more ancestors.
			break
		TV_GetText(ParentText, ParentID)
		SelectedItemText = %ParentText%\%SelectedItemText%
	}
	
	if A_GuiEvent = S			; "select new tree item"...
	{
		gTempDirName = %SelectedItemText%	; gTempDirName now has full path to the selected folder
		gosub SetWorkDir
	}
	;else if A_GuiEvent = RightClick		; TODO
	;	msgbox Right Click!
	return
	
	
;*****************************************;
;*************** Functions ***************;
;*****************************************;

